config/routes.rb
Rails.application.routes.draw do
  get 'recruitments/index'

  match '/404', :to => "errors#not_found", :via => :all
  match '/500', :to => "errors#internal_server_error", :via => :all

  resources :notifications do
    put :read
    get :follow
  end
  put 'notifications/:project_id/read_all', to: 'notifications#read_all', as: 'notifications_read_all'
  get 'notifications_check' => 'notifications#check'

  mount Attachinary::Engine => '/attachinary'

  resources :goals
  resources :cycles
  devise_for :thinkers, :controllers => {
    :sessions      => 'thinkers/sessions',
    :registrations => 'thinkers/registrations',
    :notifications => 'notifications'
  }

  resources :password, only: [:edit, :update]
  resources :otp, only: [:show] do
    member do
      put :enable
      put :disable
      put :codes
    end
  end

  resources :workloads
  resources :statuses
  resources :dependences
  resources :thinkers do
    resources :skills, except: [:show, :update, :edit], controller: 'thinkers/skills'
    resources :notifications, except: [:new], controller: 'thinkers/notifications'
    resources :preferences, only: [:edit, :update], controller: 'thinkers/preferences', path: 'thinkers/preferences', shallow: true

    member do
      get :dashboard
    end
  end
  resources :licenses
  resources :languages
  resources :projects do
    member do
      put :contribute
      put :elect
      put :migrate
      put :suspend
      put :resume
    end

    resources :teams do
      member do
        get 'ban'
        get 'unban'
      end
    end

    resources :statistics, only: [:show], controller: 'projects/statistics'

    resources :releases, shallow: true
    resources :election_polls, shallow: true
    namespace :settings, :module => :projects do
      resources :links, :controller   => :settings_links, :only   => [:index, :create]
      resources :other, :controller   => :settings_other, :only   => [:index, :create]
      resources :release, :controller => :settings_release, :only => [:index, :create]
      resources :skills, :controller => :settings_skills, except: [:show, :update, :edit]
      resources :father, :controller => :settings_father, :only => [:index, :create, :destroy]
      resources :images, :controller => :settings_images, :only => [:index, :create]
      resources :contribution_types, :controller => :settings_contribution_types, :only => [:index, :create]
    end

    resources :sprints, shallow: true do
      resources :survey, only: [:index, :create, :new]
    end

    resources :recruitments, shallow: true do
      member do
        put :approve
        put :reopen
      end
    end

    resources :tasks, shallow: true do
      member do
        put :sprint
        put :release
        put :assign
        put :judge
        put :reopen
        put :give_up
      end

      resources :comments, only: [:create, :edit, :update, :destroy], shallow: true do
        resources :reasons, shallow: true

        member do
          get :approve
          get :like
        end
      end

      resources :operations, shallow: true, except: [:new, :show] do
        member do
          put :done
        end
      end

      resource :ratings, only: [:create], shallow: true
    end

    resources :goals, shallow: true do
      member do
        put :tasks_in_sprint
      end
    end
  end
  resources :start, only: [:index]
  resources :how_does_it_works
  resources :faqs

  root "start#index"

end

app/models/dependence.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class Dependence < ActiveRecord::Base
  belongs_to :project

  def self.external
    Proc.new { |dep| !dep.external? }
  end

  validates :url, presence: true, unless: external
  validates :reason, length: { in: 20..1600 }
end

app/controllers/dependences_controller.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class DependencesController < ApplicationController
  before_action :set_dependence, only: [:show, :edit, :update, :destroy]

  # GET /dependences
  # GET /dependences.json
  def index
    @dependences = Dependence.all
  end

  # GET /dependences/1
  # GET /dependences/1.json
  def show
  end

  # GET /dependences/new
  def new
    @dependence = Dependence.new
  end

  # GET /dependences/1/edit
  def edit
  end

  # POST /dependences
  # POST /dependences.json
  def create
    @dependence = Dependence.new(dependence_params)

    respond_to do |format|
      if @dependence.save
        format.html { redirect_to @dependence, notice: 'Dependence was successfully created.' }
        format.json { render :show, status: :created, location: @dependence }
      else
        format.html { render :new }
        format.json { render json: @dependence.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /dependences/1
  # PATCH/PUT /dependences/1.json
  def update
    respond_to do |format|
      if @dependence.update(dependence_params)
        format.html { redirect_to @dependence, notice: 'Dependence was successfully updated.' }
        format.json { render :show, status: :ok, location: @dependence }
      else
        format.html { render :edit }
        format.json { render json: @dependence.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /dependences/1
  # DELETE /dependences/1.json
  def destroy
    @dependence.destroy
    respond_to do |format|
      format.html { redirect_to dependences_url, notice: 'Dependence was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_dependence
    @dependence = Dependence.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def dependence_params
    params[:dependence].permit(:reason, :url, :external, :project_id)
  end
end

app/helpers/dependences_helper.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

module DependencesHelper
end

app/views/dependences/_form.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

= form_for(@dependence) do |f|
  - if @dependence.errors.any?
    #error_explanation
      %h2
        = pluralize(@dependence.errors.count, "error")
        prohibited this dependence from being saved:
      %ul
        - @dependence.errors.full_messages.each do |message|
          %li= message
  .actions
    = f.submit

app/views/dependences/edit.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%h1 Editing Dependence
= render 'form'
= link_to 'Show', @dependence
|
= link_to 'Back', dependences_path

app/views/dependences/index.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%p#notice= notice
%h1 Listing Dependences
%table
  %thead
    %tr
      %th{:colspan => "3"}
  %tbody
    - @dependences.each do |dependence|
      %tr
        %td= link_to 'Show', dependence
        %td= link_to 'Edit', edit_dependence_path(dependence)
        %td= link_to 'Destroy', dependence, method: :delete, data: { confirm: 'Are you sure?' }
%br/
= link_to 'New Dependence', new_dependence_path

app/views/dependences/new.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%h1 New Dependence
= render 'form'
= link_to 'Back', dependences_path

app/views/dependences/show.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%p#notice= notice
= link_to 'Edit', edit_dependence_path(@dependence)
|
= link_to 'Back', dependences_path